/*     GRAM4        */

analisis(F,X,Y):- asercion(F,X,Y).

asercion(S) --> sn(K,S2,S), 
                verb(K,X,S1),
                compl(X,S1,S2).


compl([],S,S)--> [].
compl([arg(X,K)|Y],S1,S)--> 
         prep(X),
         sn(K,S2,S),
         compl(Y,S1,S2).
compl([arg(nulo,K)|Y],S1,S)-->
         sn(K,S2,S),
         compl(Y,S1,S2).

sn(K,F,F)--> npr(K).
sn(K,S2,F)--> det(K,S1,S2,F),n(K,S1).

verb(S,A,F)--> [W],{verbo(W,S,A,F)}.
npr(W)--> [W],{npropio(W)}.
n(K,F)--> [W],{nombre(W,K,F)}.
det(K,S1,S2,F)--> [W],{determ(W,K,S1,S2,F)}.
prep(W)--> [W],{prepo(W)}.


/* LEXICON GRAM4*/

npropio(clara).
npropio(maria).
npropio(juan).
npropio(barcelona).

nombre(libro,K,libro(K)).
nombre(hombre,K,hombre(K)).
nombre(profesor,K,profesor(K)).

determ(el,K,S1,S2,e(K,and(S1,S2))).
determ(un,K,S1,S2,e(K,and(S1,S2))).
determ(los,K,S1,S2,a(K,implies(S1,S2))).
determ(todo,K,S1,S2,a(K,implies(S1,S2))).

prepo(en).
prepo(con).
prepo(de).

verbo(rie,S,[],reir(S)).
verbo(piensa,S,[arg(en,O)],pensar_en(S,O)).
verbo(habla,S,[arg(de,O),arg(con,O1)],comunica(S,O,O1)).
verbo(habla,S,[arg(con,O),arg(de,O1)],comunica(S,O1,O)).
verbo(esta,S,[arg(en,O)],locativo(S,O)).
verbo(lee,S,[arg(nulo,O)],leer(S,O)).
