/*     GRAM5        */

analisis(F,X,Y):- asercion(F,X,Y).

asercion(S) --> sn(K,S2,S,Sem1), 
                verb(K,X,S1,asem(Sem1,Sem2)),
                compl(X,S1,S2,Sem2).

compl([],S,S,[])--> [].
compl([arg(X,K)|Y],S1,S,[Sem1|Sem2])-->
                  prep(X),
		  sn(K,S2,S,Sem1),
		  compl(Y,S1,S2,Sem2).
compl([arg(nulo,K)|Y],S1,S,[Sem1|Sem2])-->
                  sn(K,S2,S,Sem1),
                  compl(Y,S1,S2,Sem2).

sn(K,F,F,Sem)--> npr(K,Sem).
sn(K,S2,F,Sem)--> det(K,S1,S2,F),n(K,S1,Sem).

verb(S,A,F,AS)--> [W],{verbo(W,S,A,F,AS)}.
npr(W,S)--> [W],{npropio(W,S)}.
n(K,F,S)--> [W],{nombre(W,K,F,S)}.
det(K,S1,S2,F)--> [W],{determ(W,K,S1,S2,F)}.
prep(W)--> [W],{prepo(W)}.




















/* LEXICON GRAM5  */

npropio(clara,humano).
npropio(maria,humano).
npropio(juan,humano).
npropio(barcelona,locativo).

nombre(libro,K,libro(K),inanimado).
nombre(hombre,K,hombre(K),humano).
nombre(profesor,K,profesor(K),humano).
nombre(perro,K,profesor(K),animado).
nombre(gato,K,gato(K),animado).
nombre(camino,K,camino(K),locativo).
nombre(pescado,K,pescado(K),inanimado).

determ(el,K,S1,S2,e(K,and(S1,S2))).
determ(un,K,S1,S2,e(K,and(S1,S2))).
determ(los,K,S1,S2,a(K,implies(S1,S2))).
determ(todo,K,S1,S2,a(K,implies(S1,S2))).

prepo(en).
prepo(con).
prepo(de).

verbo(rie,S,[],reir(S),asem(humano,[])).
verbo(piensa,S,[arg(en,O)],pensar_en(S,O),
      asem(humano,[_])).
verbo(habla,S,[arg(de,O),arg(con,O1)],
      comunica(S,O,O1),asem(humano,[_,humano])).
verbo(habla,S,[arg(con,O),arg(de,O1)],
      comunica(S,O1,O),asem(humano,[humano,_])).
verbo(esta,S,[arg(en,O)],locativo(S,O),
      asem(_,[locativo])).
verbo(lee,S,[arg(nulo,O)],leer(S,O),
      asem(humano,[inanimado])).
verbo(corre,S,[arg(en,O)],correr(S,O),
      asem(animado,[locativo])).
verbo(come,S,[arg(en,O)],comer(S,O),
      asem(animado,[locativo])).
verbo(come,S,[arg(nulo,O)],comer(S,O),
      asem(animado,[inanimado])).
